% IEEE TRANSACTIONS ON INFORMATION THEORY, VOL. 48, NO. 4, APRIL 2002
% On Ensembles of Low-Density Parity-Check
% Asymptotic Distance Distributions
% Simon Litsyn, Senior Member, IEEE, and Vladimir Shevelev
% Ensemble A

function [Bh,Ah]=getBh(N,J,K)


M = N*J/K;
R = 1-J/K;
alpha = M/N;

theta = 1/N * [1:N];
for n=[1:N-1]
    if mod(K,2)==0  
        if n>N/2, t(N/2:N-1) = 1./t(N/2:-1:1);break;end
    else
        if theta(n)>(K-1)/K,   t=t;    break;  end
    end
    func = ['(1+T)^' num2str(K-1) '+(1-T)^' num2str(K-1) ...
            '-' num2str(1-theta(n)) '*((1+T)^' num2str(K) '+(1-T)^' num2str(K) ')'];
    %func = ['(1+T)^(K-1)+(1-T)^(K-1)- (1-theta*((1+T)^K+(1-T)^K)'];
    T = double(solve(func));
    position = find(imag(T)==0 & real(T)>0);
    t(n) = T(position);
    disp(n);
end
t(N) = 0;

H_theta = theta.*log(theta) + (1-theta).*log(1-theta);
b_theta = alpha * log(((1+t).^K+(1-t).^K)./(2*t.^(theta*K))) + (J-1)*H_theta;
b_theta(N) = 0;
Bh = b_theta;

% factor  = 830;
% B       = exp(N*b_theta - factor*log(2)); 
% B       = B*( 2^(N-M+2 - factor) /sum(B(1:N-1)) );
% 
% Ah      = B * 2^factor;

sgn  = ones(1,N);
expo = N*Bh;
[sumSgn sumExpo]=expoAdd(sgn,expo);

factor = (N-M+J-1)*log(2) - sumExpo;

Bh = Bh + factor/N;

Ah   = exp(N*Bh);
