%%
%% Ref. "On performance limits of space-time codes: ~", Fozunbal
%%


clear all

Nt=2; %# of TX antennas
Nr=2; %# of RX antennas

K=1; %# of fading blocks per codeword
L=30; %block length
R=3; %rate: bits per dimension

% EcuN0dB=30;
% EcuN0dB=[20:2:40].';
EcuN0dB=[4:2:30].';
EcuN0=10.^(EcuN0dB/10);
N0=1;
Ecu=EcuN0*N0;

N_realiz=10000; %# of channel realization

spbnd_1=zeros(size(EcuN0dB));
for j1=1:size(EcuN0dB,1),
    j1
    for i1=1:N_realiz,
        for k1=1:K,
            for n1=1:Nr,
                for n2=1:Nt,
                    H(n1,n2,k1)=gngauss(0,sqrt(0.5))+j*gngauss(0,sqrt(0.5));
                end;
            end;
        end;
        rsqopt_tmp=1;
        for k1=0:K-1,
            rsqopt_tmp=rsqopt_tmp*det(eye(Nr,Nr)+Ecu(j1,1)/Nt/N0*H(:,:,k1+1)*H(:,:,k1+1)');
        end;
        rsqopt=Nr*L*K*N0*(2^(-2*Nt/Nr*R))*(rsqopt_tmp^(1/Nr/K));
        spbnd_1_tmp=0;
        for k1=0:Nr*L*K-1, 
            spbnd_1_tmp=spbnd_1_tmp+1/factorial(k1)*((rsqopt/N0)^k1);
        end;
        spbnd_1_tmp=spbnd_1_tmp*exp(-rsqopt/N0);
        spbnd_1(j1,1)=spbnd_1(j1,1)+spbnd_1_tmp/N_realiz;
    end;
end;
spbnd_1=real(spbnd_1);
spbnd_1

for j1=1:size(EcuN0dB,1),
    spbnd_2(j1,1)=exp(-Nr*L*K*(2^(-2*Nt/Nr*R)))/((1+(2^(-2*Nt/Nr*R))*L*Ecu(j1,1)/Nt/N0)^(Nt*Nr*K))*...
                nchoosek(Nt*Nr*K+Nr*L*K-1,Nr*L*K-1);
    spbnd_3(j1,1)=1/((1+(2^(-2*Nt/Nr*R))*Nr*L*Ecu(j1,1)/min(Nt,Nr)/Nt/N0)^(Nt*Nr*K))*...
                nchoosek(Nt*Nr*K+Nr*L*K-1,Nr*L*K-1);
end;
spbnd_2
spbnd_3

semilogy(EcuN0dB,spbnd_1,'k');
hold on
semilogy(EcuN0dB,spbnd_2,'k:');
semilogy(EcuN0dB,spbnd_3,'k-.');
hold off
axis([4 30 10^(-3) 10^0])

save spbound_3b.mat
